### Method

# Gio File read

#### Declaration [src]

    GFileInputStream*
    g_file_read (
      GFile* file,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Opens a file for reading. The result is a `GFileInputStream` that can be used to read the contents of the file.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned.

If the file does not exist, the `G_IO_ERROR_NOT_FOUND` error will be returned. If the file is a directory, the `G_IO_ERROR_IS_DIRECTORY` error will be returned. Other errors are possible too, and depend on what kind of filesystem the file is on.

#### Parameters

`cancellable`

  Type: `GCancellable`

  A `GCancellable`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GFileInputStream`

`GFileInputStream` or `NULL` on error. Free the returned object with g_object_unref().

The caller of the method takes ownership of the returned data, and is responsible for freeing it.